#ifndef _STATSWRITER_H__
#define _STATSWRITER_H__

#include "common.h"
#include <fstream>
#include "Vector3.h"


namespace CHCDemoEngine
{

struct FrameStats
{
	FrameStats() {}
	FrameStats(int frame, int fps, float time, int nodes, int triangles, int objects):
	mFrame(frame), mFPS(fps), mTime(time), mNodes(nodes), mTriangles(triangles), mObjects(objects)
	{}



	////////////////

	int mFrame;
	int mFPS;
	float mTime;
	int mNodes;
	int mTriangles;
	int mObjects;


	friend std::ostream& operator<< (std::ostream &s, const FrameStats &A);
};


/// Overload << operator for C++-style output
inline std::ostream& operator<< (std::ostream &s, const FrameStats &A)
{
	s << "#FRAME" << "\n" << A.mFrame << std::endl;
	s << "#FPS" << "\n" << A.mFPS << std::endl;
	s << "TIME" << "\n" << A.mTime << std::endl;
	s << "#NODES" << "\n" << A.mNodes << std::endl;
	s << "#TRIANGLES" << "\n" << A.mTriangles << std::endl;
	s << "#OBJECTS" << "\n" << A.mObjects << std::endl;
}


/** Writes out stats
*/
class StatsWriter
{
public:

	StatsWriter(const std::string &filename);

	~StatsWriter();
	/** Writes current data
	*/
	void WriteFrameStats(const FrameStats &stats);
	

protected:

	std::ofstream mFile;
};


} // _STATSWRITER_H__

#endif
